#define UNICODE
#define _UNICODE
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <shellapi.h>
#include <tlhelp32.h>
#include <tchar.h>
#include "resource.h"

#pragma comment(linker, "/subsystem:windows,5.0 /defaultlib:kernel32.lib /defaultlib:user32.lib")

#define GUID_ALLGDIPLUSPLUS		_T("{FD21E0BB-24FB-41d4-8DB0-081D2E4DF0EC}")

#ifndef WM_TRAYICONMESSAGE
#define WM_TRAYICONMESSAGE WM_USER + 1
#endif  WM_TRAYICONMESSAGE

#define IDM_EXIT  101
#define IDM_ENABLED  102
#define IDM_DISABLED 102

HHOOK     g_hHook = NULL;
HINSTANCE g_hInstance = NULL;
HINSTANCE g_hinstDLL = NULL;
TCHAR* g_lpszAppName = _T("gdi++ManagerWnd");

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void WINAPI UnloadALL();

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	MSG  msg = {0,0,0,0,0,0};
	HWND hWnd;

	HANDLE hMutex = CreateMutex(FALSE, 0, g_lpszAppName);
	if(GetLastError() == ERROR_ALREADY_EXISTS) {
		CloseHandle(hMutex);
		return FALSE;
	}
	WNDCLASSEX wc;
	ZeroMemory(&wc, sizeof(WNDCLASSEX));
	wc.cbSize        = sizeof(WNDCLASSEX);
	wc.lpfnWndProc   = (WNDPROC)WndProc;
	wc.hInstance     = hInstance;
	wc.lpszClassName = g_lpszAppName;
	if(!RegisterClassEx(&wc)) return 0;
	g_hInstance = hInstance;

	hWnd = CreateWindow(g_lpszAppName, g_lpszAppName, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT,
		CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

	if(!hWnd) return 0;

	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg); 
		DispatchMessage(&msg);
	}
	CloseHandle(hMutex);
	return msg.wParam;
}

int InitializeHook(){
	g_hinstDLL = LoadLibrary(_T("GDI++.DLL"));
	HOOKPROC p = (HOOKPROC)GetProcAddress(g_hinstDLL, "GetMsgProc");
	if(!g_hinstDLL || !p)
		return MessageBox(NULL, _T("GDI++.DLL[hł܂"), NULL, MB_ICONHAND);
	g_hHook = SetWindowsHookEx(WH_GETMESSAGE, p, g_hinstDLL, 0);
	if(!g_hHook)
		return MessageBox(NULL, _T("tbNɎs܂"), NULL, MB_ICONHAND);
	PostMessage(HWND_BROADCAST, WM_NULL, 0, 0);
	RedrawWindow(GetDesktopWindow(), NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_ALLCHILDREN);
	return TRUE;
}

int TerminateHook(){
	UnloadALL();
	if (g_hHook) UnhookWindowsHookEx(g_hHook);	
	PostMessage(HWND_BROADCAST, WM_NULL, 0, 0);
	RedrawWindow(GetDesktopWindow(), NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_ALLCHILDREN);
	return TRUE;
}

BOOL _RemoteFreeLibrary(DWORD dwProcessId, HMODULE hModule, BOOL bForceUnload = FALSE)
{
	HANDLE hProcess = OpenProcess(PROCESS_CREATE_THREAD | PROCESS_QUERY_INFORMATION |
									PROCESS_VM_OPERATION | PROCESS_VM_WRITE | PROCESS_VM_READ,
									TRUE, dwProcessId);
	if (!hProcess)
		return FALSE;

	DWORD ret = 0;
	DWORD dwThreadId;
	HANDLE hThread;
	
	for (;;) {
		hThread = CreateRemoteThread(hProcess, NULL, 0,
									(LPTHREAD_START_ROUTINE)FreeLibrary,
									hModule, 0, &dwThreadId);

		if(!hThread) {
			ret = FALSE;
			break;
		}

		WaitForSingleObject(hThread, INFINITE);
		GetExitCodeThread(hThread, &ret);
		CloseHandle(hThread);

		if(!bForceUnload)
			break;
		if(!ret) {
			ret = TRUE;
			break;
		}
	}

	CloseHandle(hProcess);
	return ret;
}

void WINAPI UnloadALL()
{
	HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	if(hSnapshot == INVALID_HANDLE_VALUE)
		return;

	DWORD dwMyProcessId = GetCurrentProcessId();
	PROCESSENTRY32 pe = { sizeof(PROCESSENTRY32) };
	BOOL ret = Process32First(hSnapshot, &pe);

	while(ret && GetLastError() != ERROR_NO_MORE_FILES) {
		if(pe.th32ProcessID != dwMyProcessId) {
			HANDLE hSnapModule = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, pe.th32ProcessID);
			if(hSnapModule != INVALID_HANDLE_VALUE) {
				MODULEENTRY32 me = { sizeof(MODULEENTRY32) };
				ret = Module32First(hSnapModule, &me);
				while(ret && GetLastError() != ERROR_NO_MORE_FILES) {
//					MessageBox(NULL, me.szExePath, me.szModule, MB_OK);
					if(lstrcmpi(me.szModule, _T("gdi++.dll")) == 0) {
						_RemoteFreeLibrary(pe.th32ProcessID, me.hModule, TRUE);
					}
					SetLastError(0);
					ret = Module32Next(hSnapModule, &me);
				}
				CloseHandle(hSnapModule);
			}
		}
		SetLastError(0);
		ret = Process32Next(hSnapshot, &pe);
	}
	CloseHandle(hSnapshot);
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	static NOTIFYICONDATA nid;
	static BOOL bIconVisible = FALSE;
	switch(uMsg)
	{
		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDM_ENABLED:
					if (g_hHook == NULL) {
						InitializeHook();
					} else {
						TerminateHook();
					}
					break;
				case IDM_EXIT: //I
					SendMessage(hWnd, WM_CLOSE, 0, 0);
					break;
			}
		case WM_CREATE:
			if (bIconVisible) return 0;
			ZeroMemory(&nid, sizeof(NOTIFYICONDATA));
			nid.cbSize = sizeof(NOTIFYICONDATA);
			nid.hWnd = hWnd;
			nid.uID = 1;
			nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
			nid.uCallbackMessage = WM_TRAYICONMESSAGE;
			nid.hIcon = (HICON)LoadImage(g_hInstance, MAKEINTRESOURCE(IDI_APPICON), IMAGE_ICON, 16, 16, 0);
			lstrcpy(nid.szTip, _T("gdi++"));
			if(!Shell_NotifyIcon(NIM_ADD, &nid))
				return -1;
			bIconVisible = TRUE;
			break;
		case WM_TRAYICONMESSAGE:
			if(wParam == 1) {
				if(lParam == WM_RBUTTONUP) {
					POINT pt;
					MSG msg;
					GetCursorPos(&pt);
					HMENU hMenu = CreatePopupMenu();
					AppendMenu(hMenu,MF_BYCOMMAND | MF_STRING, IDM_ENABLED, _T("L(&E)"));
					AppendMenu(hMenu, MF_BYCOMMAND | MF_STRING, IDM_EXIT, _T("I(&X)"));
					if (g_hHook != NULL) CheckMenuItem(hMenu, IDM_ENABLED, MF_CHECKED);
					SetForegroundWindow(hWnd);
					TrackPopupMenu(hMenu, TPM_RIGHTBUTTON, pt.x, pt.y, 0, hWnd, NULL);
					if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
						TranslateMessage(&msg);
						DispatchMessage(&msg);
					}
					DestroyMenu(hMenu);
				}
			}
			break;
		case WM_DESTROY:
			TerminateHook();
			Shell_NotifyIcon(NIM_DELETE, &nid);
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}